package sda.jdbc.intro.v1;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.SQLException;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class InsertPerson extends JFrame {
   
   private static final long serialVersionUID = 6815975741605247675L;
   
   final PersistenceHandler persistenceHandler = new PersistenceHandler();
   
   final JTextField nameField = new JTextField(15),
                   emailField = new JTextField(20);

   final JButton toggleConnectButton = new JButton(),
                        insertButton = new JButton("Insert");

   final JPanel databaseFieldPanel = new JPanel();

   private void setDatabaseConnectionState(final boolean state) {
      if (state) {
         toggleConnectButton.setText("Disconnect");
      } else {
         toggleConnectButton.setText("Connect");
      }
      for (final Component c: databaseFieldPanel.getComponents()){
         c.setEnabled(state);
      }
   }

   public static void main(String[] args) throws SQLException {
      InsertPerson app = new InsertPerson();
      app.setVisible(true);
   }
   
   public InsertPerson (){
      super ("Add a person's data");
      
      setSize(500, 500);
      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      
      Box top = Box.createHorizontalBox();
      add(top, BorderLayout.NORTH);
      top.add(toggleConnectButton);
      
      toggleConnectButton.addActionListener(new ActionListener() {
         
         @Override
         public void actionPerformed(ActionEvent e) {
            if (persistenceHandler.isConnected()) {
               if (persistenceHandler.disconnect()){
                  setDatabaseConnectionState(false);
               } else {
                  JOptionPane.showMessageDialog(null, persistenceHandler.getErrorMessage());
               }
            } else {
               if (persistenceHandler.connect()){
                  setDatabaseConnectionState(true);
               } else {
                  JOptionPane.showMessageDialog(null, persistenceHandler.getErrorMessage());
               }
            }
         }
      });
      
      databaseFieldPanel.setLayout(new GridLayout(0, 2));
      add(databaseFieldPanel);

      databaseFieldPanel.add(new JLabel("Name:"));
      databaseFieldPanel.add(nameField);
      
      databaseFieldPanel.add(new JLabel("E-mail:"));
      databaseFieldPanel.add(emailField);
      
      insertButton.addActionListener(new ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
           if (persistenceHandler.add(nameField.getText(), emailField.getText())) {
              nameField.setText("");
              emailField.setText("");
              JOptionPane.showMessageDialog(null, "Succesfully inserted dataset");
           } else {
              JOptionPane.showMessageDialog(null, persistenceHandler.getErrorMessage());
           }
        }
      });
      databaseFieldPanel.add(Box.createGlue());
      databaseFieldPanel.add(insertButton);   
      setDatabaseConnectionState(false);
      pack();
   }
}
